//
//  iAdDemoViewController.m
//  iAdDemo
//
//  Created by Paul Lynch on 25/06/2010.
//  Copyright P & L Systems 2010. All rights reserved.
//

#import "iAdDemoViewController.h"
#import <iAd/iAd.h>

@implementation iAdDemoViewController

@synthesize bannerView, bannerPosition, bannerIsVisible;

- (BOOL) allowActionToRun {
	return YES;
}

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	bannerView = [[ADBannerView alloc] initWithFrame:CGRectZero];
	bannerView.delegate = self;
	//bannerView.frame = CGRectOffset(bannerView.frame, 0, -50);
	CGRect frame = bannerView.frame;
	frame.origin = CGPointMake(0.0, -50.0);
	bannerView.frame = frame;
	self.bannerIsVisible = NO;
	self.bannerPosition = CGPointMake(0.0, 0.0);
	bannerView.requiredContentSizeIdentifiers = [NSSet setWithObjects:ADBannerContentSizeIdentifier320x50, ADBannerContentSizeIdentifier480x32, nil];
	bannerView.currentContentSizeIdentifier = ADBannerContentSizeIdentifier320x50;
	[self.view addSubview:bannerView];
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return YES;
}

- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration {
    if (UIInterfaceOrientationIsLandscape(toInterfaceOrientation)) {
        self.bannerView.currentContentSizeIdentifier =
		ADBannerContentSizeIdentifier480x32;
		// reset banner position if required
		if (self.bannerIsVisible) {
			CGRect frame = bannerView.frame;
			frame.origin = bannerPosition;
			bannerView.frame = frame;			
		}
    } else {
        self.bannerView.currentContentSizeIdentifier =
		ADBannerContentSizeIdentifier320x50;
		// reset banner position if required
		if (self.bannerIsVisible) {
			CGRect frame = bannerView.frame;
			frame.origin = bannerPosition;
			bannerView.frame = frame;			
		}
	}
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	self.bannerView.delegate = nil;
	self.bannerView = nil;
    [super dealloc];
}

#pragma mark ADBannerViewDelegate methods

- (BOOL)bannerViewActionShouldBegin:(ADBannerView *)banner willLeaveApplication:(BOOL)willLeave {
    NSLog(@"Banner view is beginning an ad action");
    BOOL shouldExecuteAction = [self allowActionToRun]; // your application implements this method
    if (!willLeave && shouldExecuteAction) {
        // insert code here to suspend any services that might conflict with the advertisement
    }
    return shouldExecuteAction;
}

- (void)bannerViewDidLoadAd:(ADBannerView *)banner {
    if (!self.bannerIsVisible) {
        [UIView beginAnimations:@"animateAdBannerOn" context:NULL];
		// assumes the banner view is offset 50 pixels so that it is not visible.
        //banner.frame = CGRectOffset(banner.frame, 0, 50);
		CGRect frame = banner.frame;
		frame.origin = self.bannerPosition;
		banner.frame = frame;
        [UIView commitAnimations];
        self.bannerIsVisible = YES;
    }
}

- (void)bannerView:(ADBannerView *)banner didFailToReceiveAdWithError:(NSError *)error {
	if (self.bannerIsVisible) {
        [UIView beginAnimations:@"animateAdBannerOff" context:NULL];
		// assumes the banner view is at the top of the screen.
        //banner.frame = CGRectOffset(banner.frame, 0, -50);
		CGRect frame = banner.frame;
		frame.origin = CGPointMake(0.0, -50.0);
		banner.frame = frame;
        [UIView commitAnimations];
        self.bannerIsVisible = NO;
    }
}

@end
